from multiprocessing.connection import Client
from Tkinter import *

slider_values = [0,0,0,0,0]
color_file = open("color_file.txt", "r")

address = ('localhost', 6000)
#conn = Client(address, authkey='secret password')
conn = Client(address)
class App:

	def __init__(self, master):
		master.attributes("-fullscreen", True)
		self.frame = Frame(master)
		self.frame.grid(column=0,row=0, sticky=(N,W,E,S))
		self.frame.config(cursor='none')
		self.frame.pack()
		#Standard button
		self.button = Button(self.frame, bg='red',text="QUIT", fg="white", command=quit, height=2, width=5, font=("Arial",25), activebackground='red',activeforeground='white')

		self.button.grid(row = 6, column=0)
		
		self.button = Button(self.frame, bg='green',text="START", fg="white", command=self.start_dispense, height=2, width=25,font=("Arial",25),activebackground='green',activeforeground="white")
		self.button.grid(row = 6, column=1)

		self.perc_button = Button(self.frame, bg='blue',text="FILL %\n0", fg="white",font=("Arial",15),activebackground='blue',activeforeground="white")
		self.perc_button.grid(row = 6, column=2)


		#OptionMenus
		#Populate the choice list from the color file
		self.choicelist = color_file.readlines()
		print(str(self.choicelist))
		for i in range(5):
			self.choicelist[i] = self.choicelist[i].strip().split(":")[0]
		print(str(self.choicelist))
				
		#self.choicelist = ("Red", "Green", "Blue", "Yellow", "Purple")
		
		self.om_list = []
		self.om_var_list = []
		
		for i in range(5):
			self.om_var_list.append(StringVar())
			self.om_var_list[i].set(self.choicelist[4-i])
			self.om_list.append(OptionMenu(self.frame, self.om_var_list[i], *self.choicelist, command=self.colorAdjust))
			self.om_list[i].config(font=("System", 15))
			self.om_list[i].grid(row = i + 1, column = 0)
			#Set drop down menu font as well
			menu = self.frame.nametowidget(self.om_list[i].menuname)
			menu.config(font=("System",15))		
		#Scale
		
		self.slider_list = []

		for i in range(5):
			self.slider_list.append(Scale(self.frame, orient=HORIZONTAL, width=50,sliderlength=50, length=580, showvalue=1, relief="groove", troughcolor=self.om_var_list[i].get(), resolution=1, command=self.adjust))
			self.slider_list[i].grid(row = i + 1, column = 1)
	
	def adjust(self,value):
		#Adjust sliders to have a max sum of 100
		slider_sum = 0
		
		for i in range(5):
			slider_sum += self.slider_list[i].get()
			
		if(slider_sum > 100):
			#Determine which slider is being changed
			changed_slider = -1
			for i in range(5):
				if self.slider_list[i].get() != slider_values[i]:
					changed_slider = i
			#Reset the changing one to its old value
			new_val = 100 - (slider_sum - self.slider_list[changed_slider].get())
			print(new_val)
			self.slider_list[changed_slider].set(new_val)
			
			#self.slider_list[changed_slider].set(slider_values[changed_slider])			
			print(changed_slider)
		slider_sum = 0
		#Update slider_values to have the new values
		for i in range(5):
			slider_values[i] = self.slider_list[i].get()
			slider_sum += slider_values[i]	
		

		#self.perc_button = Button(self.frame, bg='blue',text="TEST\n"+str(slider_sum), fg="white",font=("Arial",10),activebackground='blue',activeforeground="white")
		#self.perc_button.grid(row = 6, column=2)
		self.perc_button.config(text="FILL %\n"+str(slider_sum))

	def colorAdjust(self,value):
		#Adjust slider background color
		for i in range(5):
			print(self.om_var_list[i].get())

			self.slider_list[i].config(troughcolor=self.om_var_list[i].get())
	
	def start_dispense(self):
		total_percent = 0
		msg = ''
		for i in range(5):
			total_percent += self.slider_list[i].get()
		
		if total_percent < 10:
			print "Must enter at least 10% of sand colors"
		
		else:
			for i in range(5):
				msg += str(self.om_var_list[4-i].get())+":"+str(self.slider_list[4-i].get())+";"
			print "Sending: "+msg
			#conn = Client(address)
			conn.send(msg)
			#conn.send('close')
			#conn.close()
			

root = Tk()
app = App(root)
root.mainloop()

