import RPi.GPIO as GPIO
import time
import sys
from multiprocessing.connection import Listener

GPIO.setmode(GPIO.BCM)

TURNTABLE_GPIO = 21
                                          
GPIO.setup(TURNTABLE_GPIO, GPIO.OUT)

turn_p = GPIO.PWM(TURNTABLE_GPIO, 47)
turn_p.start(0)
color_file = open("color_file.txt","r")
def set_speed(pulse_time, p):
        valley = 20 #time between each pulse for motor servo control (msec)
        peak = pulse_time
    
        freq = 1/((valley+peak)*0.001)
        duty = peak/(valley+peak)*100

        p.ChangeFrequency(freq)
        p.ChangeDutyCycle(duty)

def set_position(pulse_time, p):
        valley = 20 #time between each pulse for motor servo control (msec)
        peak = pulse_time
    
        freq = 1/((valley+peak)*0.001)
        duty = peak/(valley+peak)*100

        p.ChangeFrequency(freq)
        p.ChangeDutyCycle(duty)

def dispense(disp_p, percentage):
	#set_position(.9, disp_p)	
	#time.sleep(.15)
	#set_position(1.5,disp_p)
	#time.sleep(.15)
	pos = .7
	percentage = percentage - 6
	set_position(.7, disp_p)
	if percentage > 0:
		if percentage > 20:
			disp_time = .02*20 + .05*(percentage-20)
		else:
			disp_time = .02*percentage
		time.sleep(disp_time)
		
	while(pos < 1):
		pos += .05
		set_position(pos, disp_p)
		time.sleep(.15)
	set_position(0,disp_p)		

def go_home(left_home_reed, right_home_reed):
	home_dir = route(prev_color_num, 4)
	#home_dir = 1
	print(prev_color_num)
	print("dir:"+str(home_dir))
	if home_dir <  2 and home_dir >= 0:
		fast_speed = 1.4
		slow_speed = 1.45
		home_reed = right_home_reed
	elif home_dir >= 2 or home_dir < 0:
		fast_speed = 1.65
		slow_speed = 1.6
		home_reed = left_home_reed
	set_speed(fast_speed, turn_p)

	home_cntr = 0
	at_home = False
	while at_home != True:
		while GPIO.input(home_reed):
			home_cntr += 1
			if home_cntr >= 100:
				at_home = True
				print('HOME REED')
				break
		home_cntr = 0
	time.sleep(.4)
	set_speed(slow_speed, turn_p)
	time.sleep(.75)
	set_speed(0, turn_p)

		
cntr = 0
raw_color_file = color_file.readlines()
processed_color_file = []
for i in range(5):
	processed_color_file.append(raw_color_file[i].strip().split(":"))
	#Convert from string to int
	processed_color_file[i][1] = int(processed_color_file[i][1])
print(processed_color_file)
#Convet to a dictionary
color_to_num = dict(processed_color_file)
color_file.close()
print(str(color_to_num))
#color_to_num = {"Purple":4, "Yellow":3, "Blue":2, "Red":1, "Green":0}
REED_GPIO_LIST = [27, 25, 24, 23, 22]
DISPENSER_GPIO_LIST = [20, 19, 16, 13, 12]
PWM_LIST = []

#If returns > 0, go right, < 0, go left, 0 go nowhere
def route(prev_num, curr_num):
	if prev_num >= 0:
		dir = curr_num - prev_num	
		if dir > 3 or dir < -3:
			return -1*dir #Account for the 0 and 4 case, which is anomalous
		else:
			return dir
	#-1 prev_num means it first time, tell it where to go
	if curr_num <= 2:
		return 1#Go left for 0,1,2
	else:
		return -1#Go right otherwise

#Set up all the GPIO
for i in range(len(REED_GPIO_LIST)):
	GPIO.setup(REED_GPIO_LIST[i], GPIO.IN, pull_up_down=GPIO.PUD_DOWN )
	GPIO.setup(DISPENSER_GPIO_LIST[i], GPIO.OUT)
	p = GPIO.PWM(DISPENSER_GPIO_LIST[i], 47)
	p.start(0)
	#set_position(1.5, p)
	set_position(0, p)
	PWM_LIST.append(p)
	
address = ('localhost', 6000)
listener = Listener(address)
conn = listener.accept()
print 'connection accepted from', listener.last_accepted
while True:
	msg = conn.recv()
	#conn.close()
	#listener.close()
	
	print(str(msg))
	split_msg = msg.split(";")[:-1]

	print(split_msg)

	colors = []
	percents = []

	for i in split_msg:
		ui = i.split(":")
		print ui 
		colors.append(ui[0])
		percents.append(round(float(ui[1]), -1))

	print "Colors:"+str(colors)
	print "Percents"+str(percents)
		
	time.sleep(.25)
	#set_speed(1.4, turn_p)
	#time.sleep(.75)

	prev_color_num = -1 
	#set_speed(1.3, turn_p)
	#time.sleep(.1)
	for curr_entry in range(len(colors)):
		color_complete = False
		color = colors[curr_entry]
		percent = percents[curr_entry]
		print color
		print percent
		index = color_to_num[color]
		curr_color_num = index
		print index
		TARGET_REED = REED_GPIO_LIST[index]
		TARGET_DISPENSER = DISPENSER_GPIO_LIST[index]
		TARGET_PWM = PWM_LIST[index]
		
		print "begin"

		if(percent == 0):
			color_complete = True
		else:
			#Update our location
			turn_dir = route(prev_color_num, curr_color_num)
			prev_color_num = curr_color_num
			if turn_dir > 0:
				fast_speed = 1.4
				slow_speed = 1.45
			elif turn_dir < 0:
				fast_speed = 1.65
				slow_speed = 1.6
			else:
				fast_speed = 0
				slow_speed = 0	
			set_speed(fast_speed, turn_p)

		while color_complete != True:
			while GPIO.input(TARGET_REED):
				 #print('25')
				cntr += 1
				if cntr >= 100:
					set_speed(slow_speed, turn_p)
					time.sleep(.4)
					set_speed(0, turn_p)
					dispense(TARGET_PWM, percent)
					color_complete = True
					time.sleep(.3*percent)
					print('triggered')
					break
			cntr = 0

	print("GOING HOME")
	go_home(27,22)

conn.close()
listener.close()

for p in PWM_LIST:
	#set_position(1.5, p)
	set_position(0, p)
	p.stop()

turn_p.stop()
GPIO.cleanup()
quit()
			


