from multiprocessing.connection import Client
from Tkinter import *

address = ('localhost', 6000)
#conn = Client(address, authkey='secret password')

class App:

	def __init__(self, master):
		self.frame = Frame(master)
		self.frame.grid(column=0,row=0, sticky=(N,W,E,S))
		self.frame.pack()
		#Standard button
		self.button = Button(self.frame, text="QUIT", fg="red", command=quit)
		self.button.grid(row = 0, column=0)
		
		self.button = Button(self.frame, text="START", fg="blue", command=self.start_dispense)
		self.button.grid(row = 0, column=1)

		#OptionMenus
		self.choicelist = ("red", "green")
		
		self.om_list = []
		self.om_var_list = []
		
		for i in range(2):
			self.om_var_list.append(StringVar())
			self.om_var_list[i].set(self.choicelist[i])
			self.om_list.append(OptionMenu(self.frame, self.om_var_list[i], *self.choicelist, command=self.colorAdjust))
			self.om_list[i].grid(row = i + 1, column = 0)
		
		#Scale
		
		self.slider_list = []
		
		for i in range(2):
			self.slider_list.append(Scale(self.frame, orient=HORIZONTAL, width=50,sliderlength=50, length=600, showvalue=1, relief="groove", troughcolor=self.om_var_list[i].get(), resolution=1, command=self.adjust))
			self.slider_list[i].grid(row = i + 1, column = 1)
		
	def adjust(self,value):
		#Adjust sliders to have a max sum of 100
		new_values  = [0,0]
		slider_sum = 0
		
		for i in range(2):
			slider_sum += self.slider_list[i].get()
			
		if(slider_sum > 100):
			for i in range(2):
				new_values[i] = 100
				for n in range(0,i):
					new_values[i] = new_values[i] - self.slider_list[n].get() 
					
				for n in range(i+1,2):
					new_values[i] = new_values[i] - self.slider_list[n].get() 

				print(new_values)
				
			for i in range(2):
				self.slider_list[i].set(new_values[i])
	
	def colorAdjust(self,value):
		#Adjust slider background color
		for i in range(2):
			print(self.om_var_list[i].get())
			self.slider_list[i].config(troughcolor=self.om_var_list[i].get())
	
	def start_dispense(self):
		total_percent = 0
		msg = ''
		for i in range(2):
			total_percent += self.slider_list[i].get()
		
		if total_percent < 100:
			print "Must enter 100% of sand colors"
		
		else:
			for i in range(2):
				msg += str(self.om_var_list[i].get())+":"+str(self.slider_list[i].get())+";"
			print "Sending: "+msg
			conn = Client(address)
			conn.send(msg)
			#conn.send('close')
			conn.close()
			
root = Tk()
app = App(root)
root.mainloop()

