import RPi.GPIO as GPIO
import time
import sys
from multiprocessing.connection import Listener

GPIO.setmode(GPIO.BCM)

TURNTABLE_GPIO = 21
                                          
GPIO.setup(TURNTABLE_GPIO, GPIO.OUT)

turn_p = GPIO.PWM(TURNTABLE_GPIO, 47)
turn_p.start(0)

def set_speed(pulse_time, p):
        valley = 20 #time between each pulse for motor servo control (msec)
        peak = pulse_time
    
        freq = 1/((valley+peak)*0.001)
        duty = peak/(valley+peak)*100

        p.ChangeFrequency(freq)
        p.ChangeDutyCycle(duty)

def set_position(pulse_time, p):
        valley = 20 #time between each pulse for motor servo control (msec)
        peak = pulse_time
    
        freq = 1/((valley+peak)*0.001)
        duty = peak/(valley+peak)*100

        p.ChangeFrequency(freq)
        p.ChangeDutyCycle(duty)

def dispense(disp_p, percent):
	#while percent > 0:
	#	set_position(.55, disp_p)
	#	time.sleep(.5)
	#	set_position(2.5, disp_p)
	#	time.sleep(.8*(10.0/10.0))
	#	set_position(.55, disp_p)
	#	percent = percent - 10.0
	#	time.sleep(.5)
	time.sleep(2)
	
cntr = 0

color_to_num = {"red":1, "green":0}
REED_GPIO_LIST = [27, 25]
DISPENSER_GPIO_LIST = [20, 19]
PWM_LIST = []

#Set up all the GPIO
for i in range(len(REED_GPIO_LIST)):
	GPIO.setup(REED_GPIO_LIST[i], GPIO.IN)
	GPIO.setup(DISPENSER_GPIO_LIST[i], GPIO.OUT)
	p = GPIO.PWM(DISPENSER_GPIO_LIST[i], 47)
	p.start(0)
	#set_position(1.5, p)
	set_position(0, p)
	PWM_LIST.append(p)
	
address = ('localhost', 6000)
listener = Listener(address)
conn = listener.accept()
print 'connection accepted from', listener.last_accepted

msg = conn.recv()
conn.close()
listener.close()

print(str(msg))

split_msg = msg.split(";")[:-1]

print(split_msg)

colors = []
percents = []

for i in split_msg:
	ui = i.split(":")
	print ui 
	colors.append(ui[0])
	percents.append(round(float(ui[1]), -1))

print "Colors:"+str(colors)
print "Percents"+str(percents)
	
time.sleep(.25)
set_speed(1.4, turn_p)
time.sleep(.75)

for curr_entry in range(len(colors)):
	color_complete = False
	color = colors[curr_entry]
	percent = percents[curr_entry]
	print color
	print percent
	index = color_to_num[color]
	print index
	TARGET_REED = REED_GPIO_LIST[index]
	TARGET_DISPENSER = DISPENSER_GPIO_LIST[index]
	TARGET_PWM = PWM_LIST[index]
	
	print "begin"
	while color_complete != True:
		
		if GPIO.input(TARGET_REED) and cntr < 1000:
			cntr = cntr + 1
		
		elif cntr >= 1000:
			set_speed(0, turn_p)
			time.sleep(1)
			dispense(TARGET_PWM, percent)
			set_speed(1.4, turn_p)
			cntr = 0
			print "cool"
			color_complete = True
			
		
		else:
			cntr = 0

set_speed(1.4, turn_p)
time.sleep(1)

for p in PWM_LIST:
	#set_position(1.5, p)
	set_position(0, p)
	p.stop()

turn_p.stop()
GPIO.cleanup()
quit()
			


